import 'package:flutter/cupertino.dart';
import 'package:forma/model_form.dart';
import 'adapters/string_element_adapter.dart';
import 'package:forma/element_form.dart';

class MaterialModelForm<T> extends ModelForm<T> {
  MaterialModelForm(T model, dynamic Function(T) toHash, T Function(dynamic) fromHash, Widget Function(BuildContext, dynamic) build)
      : super(
            model,
            [
              // Material form adapters
              // Specific type adapters

              // Fallback is primitive adapter
              StringElementAdapter()
            ],
            toHash,
            fromHash,
            build);

  static MaterialModelForm withLayout<T>(
      ILayout layout, T model, dynamic Function(T) toHash, T Function(dynamic) fromHash) {
    return MaterialModelForm<T>(model, toHash, fromHash, layout.layout);
  }
}
